import java.io.*;
import java.util.*;

public class OneRun {
    public static void main(String[] args) {
	if (args.length != 3 && args.length != 2) {
	    System.out.println("Usage: genRead psg readLen numReads");
	    System.out.println(" -OR-");
	    System.out.println("Usage: genRead psg readfile");
	    System.exit(0);
	}

	String filename = args[0];
	SpliceGraph s = new SpliceGraph(filename);
	s = new SpliceGraph(filename);
	String[] reads_1 = null;

	if (args.length == 3) {
	    int howLong = Integer.parseInt(args[1]);
	    int numReads = Integer.parseInt(args[2]);
	    reads_1 = s.generateReads(numReads,howLong);
	}
	else if (args.length == 2) {
	    String readfile = args[1];
	    ArrayList<String> lines = new ArrayList<String>();
	    try {
		Scanner r = new Scanner(new File(readfile));
		while (r.hasNextLine()) {
		    String line = r.nextLine();
		    lines.add(line);
		}
		reads_1 = Utility.StringArray(lines);
	    }
	    catch (IOException ioe) {
		System.out.println(readfile+" contains an error.");
		System.exit(0);
	    }
	}

	System.out.println("Initial ll: "+s.getLogLikelihood(reads_1));
// 	s.resetEdgeWeights();
	s.learnEM(reads_1,1);
    }

    // calculates Euclidean distance between two vectors
    private static double euclid(double[] a, double[] b) {
	double result = 0;
	for (int i=0; i<a.length; i++) {
	    result += Math.pow(a[i]-b[i],2);
	}
	return Math.sqrt(result);
    }
    
    // calculates Manhattan distance between two vectors
    private static double manhattan(double[] a, double[] b) {
	double result = 0;
	for (int i=0; i<a.length; i++) {
	    result += Math.abs(a[i]-b[i]);
	}
	return result;
    }
}
